"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeOptions = void 0;
const devkit_1 = require("@nx/devkit");
const js_1 = require("@nx/js");
function normalizeDirectory(options) {
    var _a;
    const { projectDirectory } = (0, devkit_1.extractLayoutDirectory)((_a = options.directory) !== null && _a !== void 0 ? _a : '');
    return projectDirectory
        ? `${(0, devkit_1.names)(projectDirectory).fileName}/${(0, devkit_1.names)(options.name).fileName}`
        : (0, devkit_1.names)(options.name).fileName;
}
function normalizeProjectName(options) {
    return normalizeDirectory(options).replace(new RegExp('/', 'g'), '-');
}
function normalizeOptions(host, options) {
    var _a, _b, _c, _d, _e;
    const appDirectory = normalizeDirectory(options);
    const appProjectName = normalizeProjectName(options);
    const { layoutDirectory } = (0, devkit_1.extractLayoutDirectory)((_a = options.directory) !== null && _a !== void 0 ? _a : '');
    const appsDir = layoutDirectory !== null && layoutDirectory !== void 0 ? layoutDirectory : (0, devkit_1.getWorkspaceLayout)(host).appsDir;
    const projectRoot = (0, devkit_1.normalizePath)(`${appsDir}/${appDirectory}`);
    const parsedTags = options.tags
        ? options.tags.split(',').map((s) => s.trim())
        : [];
    options.strict = (_b = options.strict) !== null && _b !== void 0 ? _b : true;
    options.unitTestRunner = (_c = options.unitTestRunner) !== null && _c !== void 0 ? _c : 'vitest';
    const styleExtension = options.style !== 'none' ? options.style : null;
    return Object.assign(Object.assign({}, options), { projectName: appProjectName, projectRoot, offsetFromRoot: (0, devkit_1.offsetFromRoot)(projectRoot), rootTsConfigPath: (0, js_1.getRelativePathToRootTsConfig)(host, projectRoot), styleExtension, setupVitest: options.unitTestRunner === 'vitest', parsedTags, devServerPort: (_d = options.devServerPort) !== null && _d !== void 0 ? _d : 5173, previewServerPort: (_e = options.previewServerPort) !== null && _e !== void 0 ? _e : 4173 });
}
exports.normalizeOptions = normalizeOptions;
//# sourceMappingURL=normalize-options.js.map