"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeOptions = void 0;
const devkit_1 = require("@nx/devkit");
function getE2eProjectName(options) {
    return (0, devkit_1.names)(options.project + '-e2e').fileName;
}
function normalizeDirectory(options) {
    var _a;
    const name = getE2eProjectName(options);
    const { projectDirectory } = (0, devkit_1.extractLayoutDirectory)((_a = options.directory) !== null && _a !== void 0 ? _a : '');
    return projectDirectory
        ? `${(0, devkit_1.names)(projectDirectory).fileName}/${(0, devkit_1.names)(name).fileName}`
        : (0, devkit_1.names)(name).fileName;
}
function normalizeOptions(tree, options) {
    var _a, _b;
    const extracted = (0, devkit_1.extractLayoutDirectory)((_a = options.directory) !== null && _a !== void 0 ? _a : '');
    const appsDir = (_b = extracted.layoutDirectory) !== null && _b !== void 0 ? _b : (0, devkit_1.getWorkspaceLayout)(tree).appsDir;
    const fullProjectDirectory = normalizeDirectory(options);
    const projectRoot = (0, devkit_1.normalizePath)(`${appsDir}/${fullProjectDirectory}`);
    return Object.assign(Object.assign({}, options), { e2eProjectName: getE2eProjectName(options), projectRoot, projectDirectory: fullProjectDirectory });
}
exports.normalizeOptions = normalizeOptions;
//# sourceMappingURL=normalize-options.js.map