"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeOptions = void 0;
const devkit_1 = require("@nx/devkit");
const linter_1 = require("@nx/linter");
function normalizeOptions(tree, schema) {
    var _a, _b, _c, _d, _e;
    const extracted = (0, devkit_1.extractLayoutDirectory)((_a = schema.directory) !== null && _a !== void 0 ? _a : '');
    const name = (0, devkit_1.names)(schema.name).fileName;
    const fullProjectDirectory = extracted.projectDirectory
        ? `${(0, devkit_1.names)(extracted.projectDirectory).fileName}/${name}`
        : name;
    const projectName = fullProjectDirectory.replace(new RegExp('/', 'g'), '-');
    const { libsDir: defaultLibsDir } = (0, devkit_1.getWorkspaceLayout)(tree);
    const libsDir = (_b = extracted.layoutDirectory) !== null && _b !== void 0 ? _b : defaultLibsDir;
    const projectRoot = (0, devkit_1.joinPathFragments)(libsDir, fullProjectDirectory);
    const parsedTags = schema.tags
        ? schema.tags.split(',').map((s) => s.trim())
        : [];
    const withDefaultValues = Object.assign(Object.assign({}, schema), { style: (_c = schema.style) !== null && _c !== void 0 ? _c : 'css', unitTestRunner: (_d = schema.unitTestRunner) !== null && _d !== void 0 ? _d : 'vitest', linter: (_e = schema.linter) !== null && _e !== void 0 ? _e : linter_1.Linter.EsLint, buildable: !!schema.buildable, storybookConfiguration: !!schema.storybookConfiguration, generateComponent: schema.generateComponent !== false });
    return Object.assign(Object.assign({}, withDefaultValues), { projectName,
        projectRoot, projectDirectory: fullProjectDirectory, parsedTags, setupVitest: withDefaultValues.unitTestRunner === 'vitest', offsetFromRoot: (0, devkit_1.offsetFromRoot)(projectRoot) });
}
exports.normalizeOptions = normalizeOptions;
//# sourceMappingURL=normalize-options.js.map