"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensureMdxTypeInTsConfig = exports.ensureRootTsxExists = void 0;
const devkit_1 = require("@nx/devkit");
const path_1 = require("path");
/** Creates root.tsx if it is not found */
function ensureRootTsxExists(tree, projectName) {
    var _a;
    const projectConfig = (0, devkit_1.readProjectConfiguration)(tree, projectName);
    const sourceRoot = (_a = projectConfig.sourceRoot) !== null && _a !== void 0 ? _a : (0, path_1.join)(projectConfig.root, 'src');
    const rootTsxPath = (0, path_1.join)(sourceRoot, 'root.tsx');
    if (!tree.exists(rootTsxPath)) {
        tree.write(rootTsxPath, rootTsxContent);
    }
}
exports.ensureRootTsxExists = ensureRootTsxExists;
const rootTsxContent = `// This is explicitly empty, but serves as a compilation entry-point for the client mode.
export default {};`;
function ensureMdxTypeInTsConfig(tree, projectName) {
    var _a, _b;
    var _c;
    const projectConfig = (0, devkit_1.readProjectConfiguration)(tree, projectName);
    const tsConfigPath = (0, path_1.join)(projectConfig.root, 'tsconfig.json');
    if (tree.exists(tsConfigPath)) {
        const tsConfig = (0, devkit_1.readJson)(tree, tsConfigPath);
        if (!((_b = (_c = ((_a = tsConfig.compilerOptions) !== null && _a !== void 0 ? _a : (tsConfig.compilerOptions = {}))).types) !== null && _b !== void 0 ? _b : (_c.types = [])).includes('mdx')) {
            tsConfig.compilerOptions.types.push('mdx');
            tree.write(tsConfigPath, JSON.stringify(tsConfig));
        }
    }
}
exports.ensureMdxTypeInTsConfig = ensureMdxTypeInTsConfig;
//# sourceMappingURL=ensure-file-utils.js.map